/****************************************************************
 *
 * launch.c
 *
 ****************************************************************/
#include <stdio.h>
#include <netdb.h> 
#include <sys/types.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>

void failure(char *msg);

void parseIPaddress(char *IP, char *name, char *host)
{
  char *ptr, *pos;
  int len, i;

  ptr = IP;
  pos = strchr(ptr, 64); /* code of @ */
  len = (int)pos - (int)ptr;
  memcpy(name, ptr, len);
  name[len]='\0';
  ptr += len+1;
  memcpy(host, ptr, strlen(IP)-len-1);
  host[strlen(IP)-len-1]='\0';
/*  printf("parseIP: name: %s host: %s|\n", name, host);*/
} /* parseIPaddress() */


int
findproc(char *proc)
{
  int err, pid, i;
  FILE *fp;
  char command[256];
  char name[9];

  for(i=0;i<8;i++)
    name[i]=proc[i];
  name[8]='\0';
  strcpy(command, "ps -e | grep ");
  strcat(command, name);
  strcat(command, " > .result");

  err = system(command);
  if (err == -1)
  {
    failure("launcher error");
    return err;
  }

  pid=0;
  fp = fopen(".result", "r");
  if (!fp)
  {
    failure("launcher: file open error");
    return -1;
  }
  fscanf(fp, "%d", &pid);
  fclose(fp);
  system("rm .result");
/*  printf("%s pid = %d\n", proc, pid);*/

  return pid;
} /* findproc() */

void failure(char *msg)
{
  fprintf(stderr, msg);
} /* failure() */

int
check_process(char *name, const char *opt)
{
  int pid;
  int err;

  pid = findproc(opt);
  if (pid<0) return -1; /* error */
  if (!pid) 
    {
      return start_process(name);
    }
  else
    {
      /* is running already */
      return -1;
    }
} /* check_process() */


int start_process(char *name)
{
  int pid;

  if((pid = fork()) < 0)
    {
      printf("Manager: fork error\n");
      return -1;
    }
  else if(pid == 0)
    {
      execl(name, 0);
    }
  else
    return pid;
}


















